<?php
/**
 *
 * @package Scroll Quoted Text
 * @copyright (c) 2014 HiFiKabin
 * @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
 *
 */

namespace hifikabin\scrollquoted\event;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * Event listener for UCP related actions
 */
class ucp_listener implements EventSubscriberInterface
{
	/** @var \phpbb\request\request */
	protected $request;

	/** @var \phpbb\template\template */
	protected $template;

	/** @var \phpbb\user */
	protected $user;


	public function __construct(\phpbb\request\request $request, \phpbb\template\template $template, \phpbb\user $user)
	{
		$this->request		= $request;
		$this->template		= $template;
		$this->user			= $user;
	}

	/**
	 * Assign functions defined in this class to event listeners in the core
	 *
	 * @return array
	 * @static
	 * @access public
	 */
	static public function getSubscribedEvents()
	{
		return array(
			'core.ucp_prefs_personal_data'			=> 'ucp_prefs_get_data',
			'core.ucp_prefs_personal_update_data'	=> 'ucp_prefs_set_data',
		);
	}

	public function ucp_prefs_get_data($event)
	{
		{
			$this->user->add_lang_ext('hifikabin/scrollquoted', 'scrollquoted');
		}

		// Request the user option vars and add them to the data array
		$event['data'] = array_merge($event['data'], array(
			'scrollquoted'				=> $this->request->variable('scrollquoted', (int) $this->user->data['scrollquoted']),
		));

		// Output the data vars to the template (except on form submit)
		if (!$event['submit'])
		{

			$this->template->assign_vars(array(
				'S_SCROLLQUOTED'				=> $event['data']['scrollquoted'],
			));
		}
	}

	public function ucp_prefs_set_data($event)
	{
		$event['sql_ary'] = array_merge($event['sql_ary'], array(
			'scrollquoted'					=> $event['data']['scrollquoted'],
		));
	}
}
